<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Docs</title>
</head>
<body>
    <h1>NodeJS</h1>
    <h3>NodeJS architecture</h3>
    <p>Nodejs architecture is single thread loop which handles multiple clients i.e.., servers</p>
    <h4>what is single thread loop?</h4>
    <p>only 1 thread repeatedly fetches the event.</p>
    <p>Using queue and processes it</p>
    <p>manually saves the state and goes to the processing for next event</p>
    <p>well suited for distributed systems</p>

    <small>it can handle two databases i.e.., mongodb and mysql</small>
    <small>mysql is for persistant storage and mongodb is for dispatch state</small>

    <p>provides event drivewn architecture and non blocking i/o which is scalable</p>
    <p> it doesn't waits for the request to complete, so it moves to other requests and processes it</p>

    <h4>features:</h4>
    <p>1.single threaded</p>
    <p>2.very fast</p>
    <p>3.no buffering</p>

    <small>callback is used in async function not in sync function</small>


    <p>for opening file we use fs.open(path,flags[mode],callback) --------- opening in asynch mode</p>
    <p>for opening file we use fs.open(path,flags[mode]) --------- opening in synch mode</p>
    <p>for closing the file fs.close(fd,callback)</p>

    <p>for reading the file read(fd,buffer,offset,length,position,callback)</p>
    <p>readFile([options],callback) asynch method</p>
    <p>readFileSync(file,[options]) sync method</p>

    <p>for writing into file writeFile(file,data[options],callback) asynch method</p>
    <p>writeFileSync(file,data,[options]) sync method</p>



</body>
</html>